"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _EditorDialog = _interopRequireDefault(require("../Editor/EditorDialog"));

var _CommentList = _interopRequireDefault(require("./CommentList"));

var _GoogleSignIn = _interopRequireDefault(require("../SocialLogin/GoogleSignIn"));

var _FacebookSignIn = _interopRequireDefault(require("../SocialLogin/FacebookSignIn"));

var _CommentStore = _interopRequireDefault(require("../../DataProvider/CommentStore"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _readOnlyError(name) { throw new TypeError("\"" + name + "\" is read-only"); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ReactComment = function ReactComment(props) {
  var _userData$current, _userData$current2;

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      comments = _useState2[0],
      setComments = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isDialogOpen = _useState4[0],
      setIsDialogOpen = _useState4[1];

  var _userData = (0, _react.useRef)(null);

  var _editComment = (0, _react.useRef)(null);

  var _ref = props.configuration || {},
      showCount = _ref.showCount,
      editorRows = _ref.editorRows,
      placeholder = _ref.placeholder,
      apiUrl = _ref.apiUrl,
      allowDelete = _ref.allowDelete,
      allowEdit = _ref.allowEdit,
      commentModel = _ref.commentModel,
      commentStore = _ref.commentStore;

  var _store = (0, _react.useRef)((commentStore === null || commentStore === void 0 ? void 0 : commentStore()) || (0, _CommentStore["default"])(apiUrl));

  function fetchComments() {
    return _store.current.all();
  }

  function addComment(payload) {
    return _store.current.add(payload);
  }

  function removeComment(id) {
    return _store.current.remove(id);
  }

  function updateComment(id, payload) {
    return _store.current.edit(id, payload);
  }

  function CommentsCount() {
    return showCount && /*#__PURE__*/_react["default"].createElement("div", {
      className: "react-comments-count"
    }, "".concat(comments.length, " comments"));
  }

  function successLogin(userData) {
    _userData.current = userData;
    setIsDialogOpen(true);
  }

  function onRemoveComment(id) {
    if (confirm("Confirm delete comment") == true) {
      var onCommentRemoved = props.onCommentRemoved;
      removeComment(id).then(function () {
        onCommentRemoved === null || onCommentRemoved === void 0 ? void 0 : onCommentRemoved(id);
        fetchComments().then(function (result) {
          setComments(result);
        });
      });
    }
  }

  function onUpdateComment(text) {
    var onCommentUpdated = props.onCommentUpdated;
    updateComment(_editComment.current.id, {
      comment: text
    }).then(function () {
      _editComment.current = null;
      onCommentUpdated === null || onCommentUpdated === void 0 ? void 0 : onCommentUpdated({
        _editComment: _editComment,
        text: text
      });
      fetchComments().then(function (result) {
        setComments(result);
      });
    })["catch"](function (exception) {
      console.log(exception);
      _editComment.current = null;
    });
  }

  function onEditComment(id) {
    _editComment.current = comments.find(function (comment) {
      return comment.id == id;
    });
    if (_editComment.current) setIsDialogOpen(true);
  }

  function WriteComment() {
    var _props$configuration = props.configuration,
        facebookClientId = _props$configuration.facebookClientId,
        googleClientId = _props$configuration.googleClientId,
        writeCommentPrompt = _props$configuration.writeCommentPrompt;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "comment-social-container"
    }, /*#__PURE__*/_react["default"].createElement("span", null, writeCommentPrompt), googleClientId && /*#__PURE__*/_react["default"].createElement(_GoogleSignIn["default"], {
      clientId: googleClientId,
      onSuccessLogin: successLogin
    }), facebookClientId && /*#__PURE__*/_react["default"].createElement(_FacebookSignIn["default"], {
      appId: facebookClientId,
      onSuccessLogin: successLogin
    }));
  }

  (0, _react.useEffect)(function () {
    fetchComments().then(function (result) {
      setComments(result);
    });
  }, []);

  var getUserDataPayload = function getUserDataPayload(comment) {
    var current = _userData.current;
    var picUrl = current === null || current === void 0 ? void 0 : current.picture;
    var id = current === null || current === void 0 ? void 0 : current.id;
    if (current.platform == 'facebook') picUrl = current === null || current === void 0 ? void 0 : current.picture.data.url;
    if (current.platform == 'google') id = current === null || current === void 0 ? void 0 : current.sub;
    return {
      userId: id,
      comment: comment,
      name: current.name,
      picture: picUrl,
      email: current.email,
      createdAt: new Date()
    };
  };

  var dialogDoneclicked = function dialogDoneclicked(comment) {
    if (comment) {
      var beforeAddComment = props.beforeAddComment,
          commentTransformer = props.commentTransformer,
          onCommentAdded = props.onCommentAdded;
      setIsDialogOpen(false);

      if (_editComment.current) {
        onUpdateComment(comment);
        return;
      }

      var payload = getUserDataPayload(comment);

      if (beforeAddComment) {
        beforeAddComment(payload), _readOnlyError("payload");
      }

      if (commentTransformer) {
        commentTransformer(payload), _readOnlyError("payload");
      }

      addComment(payload).then(function () {
        onCommentAdded === null || onCommentAdded === void 0 ? void 0 : onCommentAdded(result);
        fetchComments().then(function (result) {
          setComments(result);
        });
      })["catch"](function (exception) {
        console.error(exception);
      });
    }
  };

  var userId = ((_userData$current = _userData.current) === null || _userData$current === void 0 ? void 0 : _userData$current.platform) == "google" ? _userData.current.sub : (_userData$current2 = _userData.current) === null || _userData$current2 === void 0 ? void 0 : _userData$current2.id;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(CommentsCount, null), /*#__PURE__*/_react["default"].createElement(WriteComment, null), /*#__PURE__*/_react["default"].createElement(_EditorDialog["default"], {
    open: isDialogOpen,
    rows: editorRows,
    placeholder: placeholder,
    onCancelComment: function onCancelComment() {
      _editComment.current = null;
      setIsDialogOpen(false);
    },
    onSubmitComment: dialogDoneclicked,
    userData: _userData.current,
    comment: _editComment.current
  }), /*#__PURE__*/_react["default"].createElement(_CommentList["default"], {
    comments: comments,
    onRemoveComment: onRemoveComment,
    onEditComment: onEditComment,
    allowDelete: allowDelete,
    allowEdit: allowEdit,
    userId: userId,
    commentModel: commentModel
  }));
};

var _default = ReactComment;
exports["default"] = _default;